;; This is example code for file 0 the file started by the cart filesystem
;; boot program

;; file 0 is always loaded to &8000.
org &8000

start:
di					;; disable interrupts
ld sp,&c000
im 1					;; set interrupt mode 1
ld bc,&f782			;; setup initial PPI port directions
out (c),c
ld bc,&f400			;; set initial PPI port A (AY)
out (c),c
ld bc,&f600			;; set initial PPI port C (AY direction)
out (c),c

ld bc,&7fc0			;; set initial RAM configuration
out (c),c
ld bc,&7f00+%10001100
out (c),c

;; write EI:RETI to Maskable interrrupt handler
ld a,&fb
ld (&0038),a
ld hl,&4ded
ld (&0039),hl

;; write RETN to NMI
ld hl,&55ed
ld (&0066),hl

ld hl,plus_Sequence
ld bc,&bc00+17
pu1:
ld a,(hl)
out (c),a
inc hl
dec c
jr nz,pu1

ld hl,&c000
ld e,l
ld d,h
ld (hl),0
inc hl
ld bc,&3fff
ldir

;; set initial CRTC settings (screen dimensions etc)
ld hl,end_crtc_data
ld bc,&bc0f
crtc_loop:
out (c),c
dec hl
ld a,(hl)
inc b
out (c),a
dec b
dec c
jp p,crtc_loop

include "file0_a700.asm"

plus_Sequence:
defb &ff, &0
defb &ff,&77,&b3,&51,&a8,&d4,&62,&39,&9c,&46,&2b,&15,&8a
defb &cd,&ee

crtc_data:
defb &3f, &28, &2e, &8e, &26, &00, &19, &1e, &00, &07, &00,&00,&30,&00,&c0,&00
end_crtc_data:

end start
