
// these must match defs.s
#define CRTC_R1 46  //normally 40   44 for 176
#define CRTC_R9 8
#define CRTC_R6 33  //normally 25

// 256
// 176

#define SCR_WIDTH_PIXELS_MODE_0 (CRTC_R1*2*2)
#define SCR_WIDTH_PIXELS_MODE_1 (CRTC_R1*2*4)
#define SCR_WIDTH_PIXELS_MODE_2 (CRTC_R1*2*8)

// defined by R1 of the CRTC
#define SCR_WIDTH_BYTES (CRTC_R1*2)

// defined by R6 and R9 of the CRTC
#define SCR_HEIGHT_PIXELS (CRTC_R6*CRTC_R9)

#define SCR_BASE 0x0188 ;; for 46 wide. 0x01a0 for 48 wide 
enum
{
	HW_INK_WHITE=0,
	HW_INK_SEA_GREEN=2,
	HW_INK_PASTEL_YELLOW,
	HW_INK_BLUE,
	HW_INK_PURPLE,
	HW_INK_CYAN,
	HW_INK_PINK,
	HW_INK_BRIGHT_YELLOW=10,
	HW_INK_BRIGHT_WHITE,
	HW_INK_BRIGHT_RED,
	HW_INK_BRIGHT_MAGENTA,
	HW_INK_ORANGE,
	HW_INK_PASTEL_MAGENTA,
	HW_INK_BRIGHT_GREEN=18,
	HW_INK_BRIGHT_CYAN,
	HW_INK_BLACK,
	HW_INK_BRIGHT_BLUE,
	HW_INK_GREEN,
	HW_INK_SKY_BLUE,
	HW_INK_MAGENTA,
	HW_INK_PASTEL_GREEN,
	HW_INK_LIME,
	HW_INK_PASTEL_CYAN,
	HW_INK_RED,
	HW_INK_MAUVE,
	HW_INK_YELLOW,
	HW_INK_PASTEL_BLUE
};	


enum
{
	FW_INK_BLACK=0,
	FW_INK_BLUE,
	FW_INK_BRIGHT_BLUE,
	FW_INK_RED,
	FW_INK_MAGENTA,
	FW_INK_MAUVE,
	FW_INK_BRIGHT_RED,
	FW_INK_PURPLE,
	FW_INK_BRIGHT_MAGENTA,
	FW_INK_GREEN,
	FW_INK_CYAN,
	FW_INK_SKY_BLUE,
	FW_INK_YELLOW,
	FW_INK_WHITE,
	FW_INK_PASTEL_BLUE,
	FW_INK_ORANGE,
	FW_INK_PINK,
	FW_INK_PASTEL_MAGENTA,
	FW_INK_BRIGHT_GREEN,
	FW_INK_SEA_GREEN,
	FW_INK_BRIGHT_CYAN,
	FW_INK_LIME,
	FW_INK_PASTEL_GREEN,
	FW_INK_PASTEL_CYAN,
	FW_INK_BRIGHT_YELLOW,
	FW_INK_PASTEL_YELLOW,
	FW_INK_BRIGHT_WHITE,
};	

#define CPC_PEN0_MODE1 0x00
#define CPC_PEN1_MODE1 0xf0
#define CPC_PEN2_MODE1 0x0f
#define CPC_PEN3_MODE1 0xff


#define CPC_PEN0_MODE0  0x00
#define CPC_PEN1_MODE0   0x40 
#define CPC_PEN2_MODE0   0x04
#define CPC_PEN3_MODE0   0x44
#define CPC_PEN4_MODE0   0x10
#define CPC_PEN5_MODE0   0x50
#define CPC_PEN6_MODE0   0x14
#define CPC_PEN7_MODE0   0x54
#define CPC_PEN8_MODE0   0x01
#define CPC_PEN9_MODE0   0x41
#define CPC_PEN10_MODE0  0x05
#define CPC_PEN11_MODE0  0x45
#define CPC_PEN12_MODE0  0x11
#define CPC_PEN13_MODE0  0x51
#define CPC_PEN14_MODE0  0x15
#define CPC_PEN15_MODE0  0x55

#define CPC_KEY_CURSOR_LEFT 8
#define CPC_KEY_CURSOR_RIGHT 1
#define CPC_KEY_CURSOR_DOWN 2
#define CPC_KEY_CURSOR_UP 0
#define CPC_KEY_SPACE 47
#define CPC_KEY_JOY0_LEFT 74
#define CPC_KEY_JOY0_RIGHT 75
#define CPC_KEY_JOY0_UP 72
#define CPC_KEY_JOY0_DOWN 73
#define CPC_KEY_JOY0_FIRE1 76
#define CPC_KEY_JOY0_FIRE2 77

#define CPC_KEY_1 64
#define CPC_KEY_2 65
#define CPC_KEY_3 57
#define CPC_KEY_4 56
#define CPC_KEY_5 49
#define CPC_KEY_6 48
#define CPC_KEY_7 41
#define CPC_KEY_8 40
#define CPC_KEY_9 33
#define CPC_KEY_0 32

#define CPC_KEY_F1 13
#define CPC_KEY_F2 14
#define CPC_KEY_F3 5
#define CPC_KEY_F4 20
#define CPC_KEY_F5 12
#define CPC_KEY_F6 4
#define CPC_KEY_F7 10
#define CPC_KEY_F8 11
#define CPC_KEY_F9 3

#define CPC_KEY_ESC 66

extern int cpc_GetRRegister(void);
extern int cpc_Random(void);
extern int cpc_RandomInRange(int nRange);
extern void cpc_SetRandSeed(int nSeed);

/* scan keyboard and update "current" key map */
extern void cpc_ScanKeyboard();
/* ensure key table is initialised correctly */
extern void cpc_InitKeys();

/* perform a scan of the keyboard first */
/* key codes are the same as those used by CPC BASIC INKEY command */

/* returns true if key was pressed last time but released this time */
extern int cpc_TestKeyReleased(int);

/* returns true if key was released last time, but pressed now */
extern int cpc_TestKeyPressed(int);

/* copy "current" keys to "previous" keys, "current" and "previous" are used with key pressed and key released */
extern int cpc_BackupKeys();

extern int cpc_InVsync(void);
extern void cpc_WaitVsyncEnd(void);
extern void cpc_WaitVsyncStart(void);
extern void cpc_InstallIM1Interrupt(void *);
extern void cpc_SprMask0(unsigned char * scraddr, const unsigned char * pixeladdr, int widthbytes, int heightlines);
extern void cpc_SprReplace(unsigned char * scraddr, const unsigned char * pixeladdr, int widthbytes, int heightlines);
extern unsigned char *cpc_GetScrAddr(int bytex,int liney);
extern void cpc_InitScrTable();
extern void cpc_InitMaskTable0();
extern void cpc_SetColourHW(int pen, int hwink);
extern void cpc_SetBorderHW(int hwink);
extern void cpc_SetColourFW(int pen, int fwink);
extern void cpc_SetBorderFW(int fwink);
extern void cpc_SetModeFW(int mode);
/* clear screen */
extern void cpc_CLS(int encodedpen);

/* sets 14 registers from 0 to 13 */
extern void cpc_SetCRTCRegisters(const unsigned char *registerData);

/* set more than one colour. Starts at colour 0, and sets "count" number of colours. e.g. set count to 16 for mode 0 */
extern void cpc_SetColoursHW(int count, const unsigned char *Colours);

#define MF_MODE_MASK 0x03
#define MF_LOWER_ROM_DISABLE (1<<2)
#define MF_UPPER_ROM_DISABLE (1<<3)
#define MF_INTERRUPT_COUNTER_RESET (1<<4)

// set mode and rom state using hardware
extern void cpc_SetMultiFunctionHW(int mode);

#define cpc_DisableMaskableInterrupts() __asm  di __endasm
#define cpc_EnableMaskableInterrupts() __asm  ei __endasm

#define DEBUG_BREAK \
	__asm .db 0x0ed,0x0ff __endasm
	 

