;; HL=address of data
;; DE=location to relocate it to
aks_relocate:
push hl
ld bc,10
add hl,bc

push hl
;; read length
ld c,(hl)
inc hl
ld b,(hl)
inc hl
;; BC = length
ld (table_ptr),hl ;; this is the start of the list of pointers
push hl
add hl,bc	;; length based on start of block data
ld (block_end),hl ;; this is the end of the data 
pop hl
ld c,(hl) ;; read first element
inc hl
ld b,(hl)
pop hl
add hl,bc 	;; add on start of data
ld (table_ptr_end),bc

ld hl,(table_ptr)
ld a,l
cpl
ld l,a
ld a,h
cpl
ld h,a
inc hl
ld (neg_table_ptr),hl

;; we need to fix up pointers in data
;; do data at end of block
ld ix,(block_end)
ld h,(ix-1)
ld l,(ix-2)
add hl,de
ld (ix-2),l
ld (ix-1),h

ld ix,(table_ptr_end)

fix_table_and_data:

;; read address
ld h,(ix-1)
ld l,(ix-2)
;; fix it up and store it back
add hl,de
ld (ix-2),l
ld (ix-1),h
dec ix
dec ix

ld bc,(neg_table_ptr)
add ix,bc
defb &dd
ld a,h
defb &dd
or l
ret z

push ix
;; go to address and fix up address at end
push hl
pop ix
ld h,(ix-1)
ld l,(ix-2)
add hl,de
ld (ix-2),l
ld (ix-1),h
pop ix
jr fix_table_and_data

neg_table_ptr: defw 0
table_ptr: defw 0
table_ptr_end: defw 0
block_end: defw 0



